/* (c) Matt Clark Feb 2003
 *
 * You are free to copy, change and distribute this software BUT
 * you cannot charge for it (even if you change it).
 *
 * The use of this code in your code conveys no rights over
 * your code.  So, if you wish to charge for a program that uses
 * this library that is fine.  You will have to distribute the
 * library free of charge.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Matt.Clark@Nottingham.ac.uk
 */

// build with g++ test_execute.cc -o test_execute -lpi_user -l pi_execute

#include <stdio.h>
#include <stdlib.h>
#include <ncurses.h>
#define PI_EXECUTE_DEFINES
#include "pi_execute.h"
#include "pi_user.h"
void print_async_event(int);

int main(void){
BOOL ok;
char report[PI_REPORT_SIZE];

int key,axis,i,pos,sense;
int time,ax,current_axis=0,num_index=0;
char number[100];

number[0]='\0';
	ok=pi_openboard();  // already calls init board
	if(ok==FALSE){
		printf("Failed (is the device driver installed?)\n");
		exit(1);
		}
	else{
		printf("Ok\n");
		}
	axis=pi_axis_installed();
	printf("The number of axis supported %d\n",axis);
	for(i=0;i<axis;i++){
		pi_init_axis(i);
		// this is a test program
		sense=pi_auto_set_limit(i);
		printf("Axis %d: sense %d\n",i,sense);
		}
	pi_enable_async_capture((void (*)(int))print_async_event);
	printf("Enabled async event capture\n");
	printf("Testing pi_execute\n");

	printf("Trying pi_execute(0,GA,0,report);\n");
	pi_execute(0,GA,0,report);
	printf("Got \"%s\" from the report\n",report);

	printf("Trying pi_execute(0,TV,0,report);\n");
	pi_execute(0,TV,0,report);
	printf("Got \"%s\" from the report\n",report);

	printf("Trying pi_execute(0,MA,100000,report);\n");
	pi_execute(0,MA,100000,report);
	printf("Got \"%s\" from the report\n",report);

	printf("Trying pi_execute(0,WS,0,report);\n");
	pi_execute(0,WS,0,report);
	printf("Got \"%s\" from the report\n",report);

	printf("Trying pi_execute(0,MA,0,report);\n");
	pi_execute(0,MA,0,report);
	printf("Got \"%s\" from the report\n",report);

	printf("Trying pi_execute(0,WS,0,report);\n");
	pi_execute(0,WS,0,report);
	printf("Got \"%s\" from the report\n",report);

	pi_closeboard();
	}


void print_async_event(int){
int n=0;
struct pi_stage_event_t data[32];
	n=pi_read_async_events(data, 32);
	if(n==0) return;
	printf("Asynchronous event: index=%d, axis=%d, timestamp=%ud, event= %x     ",data[0].index,data[0].axis,data[0].ts_low,data[0].event);
	}
	
